/* 
 */
var dblBuffer;
var dblBfrCntx;
var canvas;
var cntx;

var imgDemo;
var imgWidth=0;
var imgHeight=0;

var copyOffset=0;
var zoomLeft=20;
var zoomTop=20;
var zoomOffsetX=0;
var zoomOffsetY=0;

function showInfo(){
	var logoImage=document.getElementById("logo");
	logoImage.style.display="block";
	logoImage.style.width=200+"px";
	logoImage.style.height=200+"px";
	var url=logoImage.getAttribute("src");
	window.open(url,"Image","width=logoImage.stylewidth,height=logoImage.style.height,resizable=1");
}

function initialise(){
    showAppTitle();
	clearInterval(codeInterval);
	programRunning=false;
	abortCode=false;
	toggleEditables("true");
	indxBorder=25;
	if(!eventsInitialised){
	    dblBuffer=document.getElementById("doubleBuffer");
	    dblBfrCntx=dblBuffer.getContext("2d");
	    canvas=document.getElementById("canvas2D");
	    cntx=canvas.getContext("2d");
	    initialiseEvents();
	    eventsInitialised=true;
	}
	initialiseErrorFlags();
	getImage();
	if(currentPage==pgImageCopy && showExercises){
		if(selectedExercise>-1)showSolution(selectedExercise);
	}
	else{
		noOfSteps=0;
		assembleCode();
		showExercises=false;
	}
	document.getElementById("errorMessage").innerHTML="";
	if(!showExercises)initialiseHint();
	switch(currentPage){
	case pgPixelCopy:
		preparePixelCopy();
		break;
	case pgRowCopy:
		prepareRowCopy();
		break;
	case pgColumnCopy:
		prepareColumnCopy();
		break;
	case pgImageCopy:
		indxBorder=0;
		prepareImageCopy();
		break;
	case pgSortedShow:
		prepareSortedView();
		break;
	}
	setVolatileHelp();
	if(!pageHelpShown[currentPage]){
		pageHelpShown[currentPage]=true;
		$("#btnHelp").trigger("click");
	}
	else{
		if(currentPage==pgImageCopy){
			firstPromptVisible=true;
			advanceStep();
		}
	}
	placeDIVs();
}

function initialiseEvents(){
	//mouse events for doubleBufferCanvas
	dblBuffer.addEventListener("mousemove",function(evt) {
		dblBfrMouseMove(evt);
	});
	dblBuffer.addEventListener("mousedown",function(evt) {
		dblBfrMouseDown(evt);
	});
	dblBuffer.addEventListener("mouseup",function(evt) {
		dblBfrMouseUp(evt);
	});
	dblBuffer.addEventListener("mouseout",function() {
		zoomAreaGrabbed=false;
	});
	
	//mouse events for canvas2D
	canvas.addEventListener("mousemove",function(evt) {
		canvasMouseMove(evt);
	});
	canvas.addEventListener("mousedown",function(evt) {
		canvasMouseDown(evt);
	});
	canvas.addEventListener("mouseup",function(evt) {
		canvasMouseUp(evt);
	});
	
    $("#btnHelp").on("click touchstart",function(){
    	showHelp();
    	window.location.href="#openModalHelp";
    });
	
    $("#btnNew").on("click touchstart",function(){
    	initialise();
    });
    
    $("#btnDelete").on("click touchstart",function(){
    	deleteCopy();
    });
    
    $("#btnPlay").on("click touchstart",function(){
    	runCode();
    });
    
    $("#btnPause").on("click touchstart",function(){
        pauseCode();
    });
    
    $("#btnStop").on("click touchstart",function(){
        stopCode();
    });
    
    $("#btnZoomIn").on("click touchstart",function(){
    	zoomIn();
    });

    $("#btnZoomOut").on("click touchstart",function(){
    	zoomOut();
    });
}

function initialiseErrorFlags(){
	varOK=[true,true];
	startValOK=[true,true];
	endValOK=[true,true];
	stepValOK=[true,true];
	expressionOK=[true,true];
	selectedRowOK=true;
	selectedColumnOK=true;
	showErrorMessage("");
}

function preparePixelCopy(){
	jQueryAnimationRate=jQueryMaxAnimationRate/4;
	/*$("#newTool").show(jQueryAnimationRate);
	$("#runTool").hide(jQueryAnimationRate);
	$("#pauseTool").hide(jQueryAnimationRate);
	$("#zoomInTool").show(jQueryAnimationRate);
	$("#zoomOutTool").show(jQueryAnimationRate);*/

	$("#codeDiv").show(jQueryAnimationRate);
	
    $("#btnNew").show();
    $("#btnPlay").hide();
    $("#btnPause").hide();
    $("#btnStop").hide();
    $("#btnZoomIn").show();
    $("#btnZoomOut").show();
	
	zoomFactor=13;
	zoomIn();
}

function prepareRowCopy(){
	jQueryAnimationRate=jQueryMaxAnimationRate/4;
	/*$("#newTool").show(jQueryAnimationRate);
	$("#runTool").show(jQueryAnimationRate);
	$("#pauseTool").hide(jQueryAnimationRate);
	$("#zoomInTool").show(jQueryAnimationRate);
	$("#zoomOutTool").show(jQueryAnimationRate);*/

	$("#codeDiv").show(jQueryAnimationRate);
	
    $("#btnNew").show();
    $("#btnPlay").show();
    $("#btnPause").hide();
    $("#btnStop").hide();
    $("#btnZoomIn").show();
    $("#btnZoomOut").show();
	
	zoomFactor=13;
	zoomIn();
	updateCode();
	addListener("selectedRow");
	addListener("startVal1");
	addListener("endVal1");
	addListener("stepVal1");
}

function prepareColumnCopy(){
	jQueryAnimationRate=jQueryMaxAnimationRate/4;
	/*$("#newTool").show(jQueryAnimationRate);
	$("#runTool").show(jQueryAnimationRate);
	$("#pauseTool").hide(jQueryAnimationRate);
	$("#zoomInTool").show(jQueryAnimationRate);
	$("#zoomOutTool").show(jQueryAnimationRate);*/

	$("#codeDiv").show(jQueryAnimationRate);
	
	$("#btnNew").show();
    $("#btnPlay").show();
    $("#btnPause").hide();
    $("#btnStop").hide();
    $("#btnZoomIn").show();
    $("#btnZoomOut").show();
	
	zoomFactor=13;
	zoomIn();
	updateCode();
	addListener("selectedColumn");
	addListener("startVal2");
	addListener("endVal2");
	addListener("stepVal2");
}

function prepareImageCopy(){
	jQueryAnimationRate=jQueryMaxAnimationRate;
	/*$("#newTool").show(jQueryAnimationRate);
	$("#runTool").show(jQueryAnimationRate);
	$("#pauseTool").hide(jQueryAnimationRate);
	$("#zoomInTool").hide(jQueryAnimationRate);
	$("#zoomOutTool").hide(jQueryAnimationRate);*/

	$("#codeDiv").show(jQueryAnimationRate);
	
    $("#btnNew").show();
    $("#btnPlay").show();
    $("#btnPause").hide();
    $("#btnStop").hide();
    $("#btnZoomIn").hide();
    $("#btnZoomOut").hide();
	
	zoomFactor=0;
	zoomIn();
	if(!showExercises)updateCode();
	addListener("var1");
	addListener("startVal1");
	addListener("endVal1");
	addListener("stepVal1");
	addListener("var2");
	addListener("startVal2");
	addListener("endVal2");
	addListener("stepVal2");
	addListener("coord1");
	addListener("coord2");	
}

function prepareSortedView(){
	jQueryAnimationRate=jQueryMaxAnimationRate;
	/*$("#newTool").hide(jQueryAnimationRate);
	$("#runTool").hide(jQueryAnimationRate);
	$("#pauseTool").hide(jQueryAnimationRate);
	$("#zoomInTool").hide(jQueryAnimationRate);
	$("#zoomOutTool").hide(jQueryAnimationRate);*/

	$("#codeDiv").show(jQueryAnimationRate);
	$("#doubleBuffer").hide(jQueryAnimationRate);
	$("#imgDimensions").hide(jQueryAnimationRate);
	$("#zoomFactorInfo").hide(jQueryAnimationRate);

    $("#btnNew").hide();
    $("#btnPlay").hide();
    $("#btnPause").hide();
    $("#btnStop").hide();
    $("#btnZoomIn").hide();
    $("#btnZoomOut").hide();

    canvas.width=300;
	canvas.height=320;
	cntx.fillStyle="white";
	cntx.fillRect(0,0,canvas.width,canvas.height);

	addListener("var1");
	addListener("startVal1");
	addListener("endVal1");
	addListener("stepVal1");
	addListener("var2");
	addListener("startVal2");
	addListener("endVal2");
	addListener("stepVal2");
}

function drawImages(){
	dblBfrCntx.clearRect(0,0,dblBuffer.width,dblBuffer.height);
	dblBfrCntx.drawImage(imgDemo,0,0,imgDemo.width,imgDemo.height);
	cntx.fillStyle="white";
	cntx.fillRect(0,0,canvas.width,canvas.height);
	
	var jEnd=currentPage==pgImageCopy?dblBuffer.width:zoomSize;
	var jOffset=currentPage==pgImageCopy?0:zoomLeft;
	var iEnd=currentPage==pgImageCopy?dblBuffer.height:zoomSize;
	var iOffset=currentPage==pgImageCopy?0:zoomTop;
	
	var pixelData;
	for(var i=0;i<iEnd;i++){
		for(var j=0;j<jEnd;j++){
			pixelData=dblBfrCntx.getImageData(jOffset+j,iOffset+i,1,1).data;
			cntx.fillStyle="rgb("+pixelData[0]+","+pixelData[1]+","+pixelData[2]+")";
			cntx.fillRect(indxBorder/zoomFactor+j,i,1,1);			
		}
	}

	drawZoomArea();
	drawGrid(0,zoomSize,zoomSize);
	drawGrid(copyOffset,zoomSize,zoomSize);
	if(currentPage==pgRowCopy || currentPage==pgColumnCopy){
		cntx.fillStyle="blue";
		cntx.scale(1/zoomFactor,1/zoomFactor);
		cntx.fillText("picture1",indxBorder,zoomSize*zoomFactor+20);
		cntx.fillText("picture2",indxBorder+copyOffset,zoomSize*zoomFactor+20);
		cntx.scale(zoomFactor,zoomFactor);
	}
}

function drawZoomArea(){
	dblBfrCntx.beginPath();
	dblBfrCntx.lineWidth="4";
	dblBfrCntx.strokeStyle="red";
	dblBfrCntx.rect(zoomLeft-2,zoomTop-2,zoomSize+4,zoomSize+4);
	dblBfrCntx.stroke();
}

function prepareToShowImages(){
	dblBuffer.width=imgDemo.width;
	dblBuffer.height=imgDemo.height;
	$("#doubleBuffer").show(0);
	$("#imgDimensions").show(0);
	$("#zoomFactorInfo").show(0);

	sizeDIVs();

	switch(currentPage){
	case pgPixelCopy:
	case pgRowCopy:
	case pgColumnCopy:
		$("#doubleBuffer").show(0);
		drawImages();
		break;
	case pgImageCopy:
		cntx.fillStyle="white";
		cntx.fillRect(0,0,canvas.width,canvas.height);
		
		dblBfrCntx.drawImage(imgDemo,0,0,imgWidth,imgHeight);
		break;
	}
}

function sizeDIVs(){
	var divBorder=15;
	var menuVisibleEntriesCounter=$('.liMenu:visible').size();
	$("#mainMenu").css({
        width: 250+"px",
        height: 30*menuVisibleEntriesCounter+divBorder+"px"
    });
    
	var toolBoxLeft=document.getElementById("mainMenu").getBoundingClientRect().left;
	var toolBoxWidth=document.getElementById("mainMenu").getBoundingClientRect().width;
	var newTop=document.getElementById("mainImage").getBoundingClientRect().top;
	var mainImageLeft=toolBoxLeft+toolBoxWidth+divBorder;
	$("#mainImage").css({
        //top: newTop+"px",
        left: mainImageLeft+"px"
    });
	var copyImageLeft=mainImageLeft+document.getElementById("mainImage").getBoundingClientRect().width+divBorder;
    if(currentPage==pgSortedShow){
        copyImageLeft=mainImageLeft;
    }
	
	document.getElementById("mainImage").style.width=parseInt(dblBuffer.width+10)+"px";
	$("#copyImage").css({
        top: newTop+"px",
        left: copyImageLeft+"px"
    });
	var totalHeight=Math.max(document.getElementById("copyImage").offsetHeight,document.getElementById("mainImage").offsetHeight);
	//Η επόμενη εντολή καλύπτει την περίπτωση που το ύψος του copyImage δεν επαρκεί
	//επειδή στη σελίδα pgImageCopy δεν εμφανίζεται η τιμή του δείκτη μεγέθυνσης
	if(currentPage==pgImageCopy) totalHeight+=divBorder;
	$("#drawingArea").css({
        height: totalHeight+"px"
    });
}

function getImage(){
	var selector=parseInt(parseInt(1000*Math.random())/125)+1;
	//selector=10;
	var imgName="demoPic"+selector;
	imgDemo=document.getElementById(imgName);
	imgWidth=imgDemo.width;
	imgHeight=imgDemo.height;
	showMainImageInfo();
}

function showMainImageInfo(mouseX,mouseY){
	var infoToShow="";
	infoToShow=imgWidth+" x "+imgHeight;
	if(currentPage==pgImageCopy){
		infoToShow="<code>picture1</code>  ("+infoToShow+")";
	}
	if(mouseX && mouseX<imgWidth && mouseY<imgHeight){
		infoToShow+="<br>mouse("+mouseX+","+mouseY+")";
	}
	document.getElementById("imgDimensions").innerHTML=infoToShow;
}

function drawGrid(gridOffset,gridWidth,gridHeight){
	var iIndex=0;
	var jIndex=0;
	var gridIndexStep=zoomFactor>9?2:5;
	if(gridVisible){
		cntx.font=Math.max(zoomFactor-3,7)+"px Arial";
		cntx.scale(1/zoomFactor,1/zoomFactor);
		cntx.beginPath();
		cntx.fillStyle="black";
		cntx.strokeStyle="black";
		for(var i=0;i<=gridWidth;i++){
			//Εμφάνιση Α/Α στήλης
			iIndex=parseInt(i+zoomLeft);
			if (currentPage!=pgImageCopy && iIndex%gridIndexStep==0 && i<gridWidth){
				cntx.fillText(iIndex,gridOffset+indxBorder+i*zoomFactor,gridHeight*zoomFactor+10);
			}
			if(zoomFactor>5 || i==0 || i==gridWidth){
				//Σχεδίαση στήλης
				cntx.moveTo(indxBorder+gridOffset+i*zoomFactor,0);
				cntx.lineTo(indxBorder+gridOffset+i*zoomFactor,gridHeight*zoomFactor);
			}
		}
		for(var j=0;j<=gridHeight;j++){
			//Εμφάνιση Α/Α γραμμής
			jIndex=parseInt(j+zoomTop);
			if (currentPage!=pgImageCopy && jIndex%gridIndexStep==0 && j<gridWidth){
				var metrics=cntx.measureText(jIndex+" ");
				cntx.fillText(jIndex,indxBorder+gridOffset-metrics.width,j*zoomFactor+10);
			}
			if(zoomFactor>5 || j==0 || j==gridHeight){
				//Σχεδίαση γραμμής
				cntx.moveTo(indxBorder+gridOffset,j*zoomFactor);
				cntx.lineTo(indxBorder+gridOffset+gridWidth*zoomFactor,j*zoomFactor);
			}
		}
		cntx.stroke();
		cntx.scale(zoomFactor,zoomFactor);
	}
}

function transformImage(){
	var i,j;
	var pixelData;
	for (i=0;i<imgWidth;i++){
		for (j=0;j<imgHeight;j++){
			pixelData=cntx.getImageData(j,i,1,1).data;
			/*cntx.fillStyle = "rgba("+pixelData[0]+","+pixelData[1]+","+pixelData[2]+","+(pixelData[3]/255)+")";
			cntx.fillRect( i + copyOffset, j, 1, 1 );*/
			for(var k=0;k<4;k++){
				imageDataD[k]=pixelData[k];	
			}
			setInterval(function(){
				cntx.putImageData(imageData,i+copyOffset,imgHeight-j);
			},1000/15);
		}
	}
}

function runCode(){
	if(programOnPause){
		/*$("#runTool").hide(jQueryAnimationRate);
		$("#pauseTool").show(jQueryAnimationRate);
		$("#stopTool").show(jQueryAnimationRate);*/

		$("#btnPlay").hide();
		$("#btnPause").show();
		$("#btnStop").show();
		
		$(".showValues").zIndex(10);
		$("#showQuestion").zIndex(5);
		
		programOnPause=false;
	}
	else{
		abortCode=false;
		switch(currentPage){
		case pgPixelCopy:
			//χωρίς κώδικα
			break;
		case pgRowCopy:
            $("#btnZoomIn").hide();
            $("#btnZoomOut").hide();
			copyRow();
			break;
		case pgColumnCopy:
            $("#btnZoomIn").hide();
            $("#btnZoomOut").hide();
			copyColumn();
			break;
		case pgImageCopy:
			copyImage();
			break;
		case pgSortedShow:
			showSortedData();
			break;
		}
	}
}

function pauseCode(){
	programOnPause=true;
	/*$("#runTool").show(jQueryAnimationRate);
	$("#pauseTool").hide(jQueryAnimationRate);
	$("#stopTool").hide(jQueryAnimationRate);*/

    $("#btnPause").hide();
    $("#btnStop").hide();
	$("#btnPlay").show();
}

function stopCode(){
	abortCode=true;
}

function copyRow(){
	if (!programRunning){
		intervalPeriod=200;
		//καθορισμών επιτρεπτων ονομάτων μεταβλητών
		varName1="x";
		varName2="y";

		//ανάγνωση παραμέτρων
		var startVal2=UserFunctionOutput(varName1,varName2,document.getElementById("selectedRow").innerHTML,0,0);
		var endVal2=startVal2;
		var stepVal2=1;

		var startVal1=UserFunctionOutput(varName1,varName2,document.getElementById("startVal1").innerHTML,0,startVal2);
		var endVal1=UserFunctionOutput(varName1,varName2,document.getElementById("endVal1").innerHTML,0,startVal2);
		var stepVal1=UserFunctionOutput(varName1,varName2,document.getElementById("stepVal1").innerHTML,0,startVal2);

		if(Math.sign((endVal1-startVal1)*stepVal1)>=0 && stepVal1!=0 && Math.sign((endVal2-startVal2)*stepVal2)>=0 && stepVal2!=0){
			/*$("#runTool").hide(jQueryAnimationRate);
			$("#stopTool").show(jQueryAnimationRate);
			$("#zoomInTool").hide(jQueryAnimationRate);
			$("#zoomOutTool").hide(jQueryAnimationRate);*/

			$("#btnPlay").hide();
            $("#btnPause").show();
            $("#btnStop").show();
            
			programRunning=true;
			toggleEditables("false");
			executeCode(sweepByRow,startVal1,endVal1,stepVal1,startVal2,endVal2,stepVal2);			
		}
		else{
			alert("Μηδενικό πλήθος επαναλήψεων!");
		}
	}
}

function copyColumn(){
	if (!programRunning){
		intervalPeriod=200;
		//καθορισμών επιτρεπτων ονομάτων μεταβλητών
		varName1="x";
		varName2="y";

		//ανάγνωση παραμέτρων
		var startVal1=UserFunctionOutput(varName1,varName2,document.getElementById("selectedColumn").innerHTML,0,0);
		var endVal1=startVal1;
		var stepVal1=1;

		var startVal2=UserFunctionOutput(varName1,varName2,document.getElementById("startVal2").innerHTML,startVal1,0);
		var endVal2=UserFunctionOutput(varName1,varName2,document.getElementById("endVal2").innerHTML,startVal1,0);
		var stepVal2=UserFunctionOutput(varName1,varName2,document.getElementById("stepVal2").innerHTML,startVal1,0);

		if(Math.sign((endVal1-startVal1)*stepVal1)>=0 && stepVal1!=0 && Math.sign((endVal2-startVal2)*stepVal2)>=0 && stepVal2!=0){
			/*$("#runTool").hide(jQueryAnimationRate);
			$("#stopTool").show(jQueryAnimationRate);
			$("#zoomInTool").hide(jQueryAnimationRate);
			$("#zoomOutTool").hide(jQueryAnimationRate);*/

			$("#btnPlay").hide();
            $("#btnPause").show();
            $("#btnStop").show();
			
			programRunning=true;
			toggleEditables("false");
			executeCode(sweepByColumn,startVal1,endVal1,stepVal1,startVal2,endVal2,stepVal2);			
		}
		else{
			alert("Μηδενικό πλήθος επαναλήψεων!");
		}
	}
}

function copyImage(){
	if (!programRunning){
		cntx.fillStyle="white";
		cntx.fillRect(0,0,canvas.width,canvas.height);
		
		intervalPeriod=1/10;

		//καθορισμών επιτρεπτων ονομάτων μεταβλητών
		varName1="x";
		varName2="y";
		
		varName1=document.getElementById("var1").innerHTML;
		varName2=document.getElementById("var2").innerHTML;

		//ανάγνωση παραμέτρων
		var startVal1=UserFunctionOutput(varName1,varName2,document.getElementById("startVal1").innerHTML,0,0);
		var endVal1=UserFunctionOutput(varName1,varName2,document.getElementById("endVal1").innerHTML,0,0);
		var stepVal1=UserFunctionOutput(varName1,varName2,document.getElementById("stepVal1").innerHTML,0,0);

		var startVal2=UserFunctionOutput(varName1,varName2,document.getElementById("startVal2").innerHTML,startVal1,0);
		var endVal2=UserFunctionOutput(varName1,varName2,document.getElementById("endVal2").innerHTML,startVal1,0);
		var stepVal2=UserFunctionOutput(varName1,varName2,document.getElementById("stepVal2").innerHTML,startVal1,0);

		if(Math.sign((endVal1-startVal1)*stepVal1)>=0 && stepVal1!=0 && Math.sign((endVal2-startVal2)*stepVal2)>=0 && stepVal2!=0){
			var variationSelector=1;
			/*$("#runTool").hide(jQueryAnimationRate);
			$("#stopTool").show(jQueryAnimationRate);
			$("#zoomInTool").hide(jQueryAnimationRate);
			$("#zoomOutTool").hide(jQueryAnimationRate);*/
			
            $("#btnPlay").hide();
            $("#btnPause").show();
            $("#btnStop").show();
			
			programRunning=true;
			toggleEditables("false");
			if(varName1=="y"){
				variationSelector=sweepByRow;
				startVal2=UserFunctionOutput(varName1,varName2,document.getElementById("startVal1").innerHTML,0,0);
				endVal2=UserFunctionOutput(varName1,varName2,document.getElementById("endVal1").innerHTML,0,0);
				stepVal2=UserFunctionOutput(varName1,varName2,document.getElementById("stepVal1").innerHTML,0,0);

				startVal1=UserFunctionOutput(varName1,varName2,document.getElementById("startVal2").innerHTML,0,startVal2);
				endVal1=UserFunctionOutput(varName1,varName2,document.getElementById("endVal2").innerHTML,0,startVal2);
				stepVal1=UserFunctionOutput(varName1,varName2,document.getElementById("stepVal2").innerHTML,0,startVal2);
			}
			executeCode(variationSelector,startVal1,endVal1,stepVal1,startVal2,endVal2,stepVal2);			
		}
		else{
			alert("Μηδενικό πλήθος επαναλήψεων!");
		}
	}
}

function showSortedData(){
	if (!programRunning){
		var variationSelector=-1;
		intervalPeriod=200;

		//ανάγνωση παραμέτρων
		varName1=document.getElementById("var1").innerHTML;
		varName2=document.getElementById("var2").innerHTML;

		var startVal1=UserFunctionOutput(varName1,varName2,document.getElementById("startVal1").innerHTML,0,0);
		var endVal1=UserFunctionOutput(varName1,varName2,document.getElementById("endVal1").innerHTML,0,0);
		var stepVal1=UserFunctionOutput(varName1,varName2,document.getElementById("stepVal1").innerHTML,0,0);

		var startVal2=UserFunctionOutput(varName1,varName2,document.getElementById("startVal2").innerHTML,startVal1,0);
		var endVal2=UserFunctionOutput(varName1,varName2,document.getElementById("endVal2").innerHTML,startVal1,0);
		var stepVal2=UserFunctionOutput(varName1,varName2,document.getElementById("stepVal2").innerHTML,startVal1,0);
		
		if(varName1=="i"){
			variationSelector=sweepByRow;
		}
		else{
			variationSelector=sweepByColumn;
		}
		populateMatrix();
		toggleEditables("false");
		programRunning=true;
		traverseMatrix(variationSelector,startVal1,endVal1,stepVal1,startVal2,endVal2,stepVal2);
	}
}

function traverseMatrix(variationSelector,iStart,iEnd,iStep,jStart,jEnd,jStep){
    var extLoopVarName="i";
    var intLoopVarName="j";
	var previousValueShown=0;
	var valOffset=0;
	var counter=0;
	var iOld=0;
	var jOld=0;
	var i=0;
	var j=0;
	var jEndVal=0;
	cntx.strokeStyle="#FF0000";
	/*$("#runTool").hide(jQueryAnimationRate);
	$("#pauseTool").show(jQueryAnimationRate);*/

	$("#btnPlay").hide();
	$("#btnPause").show();

	if(variationSelector==sweepByRow){ //Πρώτη παραλλαγή εμφώλευσης
		i=iStart;
		j=UserFunctionOutput(varName1,varName2,document.getElementById("startVal2").innerHTML,0,i);
		jEndVal=UserFunctionOutput(varName1,varName2,document.getElementById("endVal2").innerHTML,0,i);
	}
	else{ //Δεύτερη παραλλαγή εμφώλευσης
	    extLoopVarName="j";
	    intLoopVarName="i";
		i=jStart;
		j=UserFunctionOutput(varName1,varName2,document.getElementById("startVal1").innerHTML,j,0);
		jEndVal=UserFunctionOutput(varName1,varName2,document.getElementById("endVal1").innerHTML,j,0);
		var temp=iStep;
		iStep=jStep;
		jStep=temp;

		temp=iStart;
		iStart=jStart;
		jStart=temp;

		temp=iEnd;
		iEnd=jEnd;
		jEnd=temp;
	}
	if(resultsStyle==0){
		//Επικεφαλίδες πίνακα παρακολούθησης
		cntx.font="11px Georgia";
		cntx.fillStyle="blue";
		cntx.fillText("i",5*matrixBorder/3+noOfColumns*cellWidth,cellHeight/2);
		cntx.fillText("j",5*matrixBorder/3+(noOfColumns+0.5)*cellWidth,cellHeight/2);
		cntx.fillText("Τιμή",5*matrixBorder/3+(noOfColumns+1)*cellWidth,cellHeight/2);
	}
	previousValueShown=currentMatrix[i-1][j-1];
	codeInterval=setInterval(function(){
		if(programOnPause) return;
		if(abortCode){
			tideUpCode(iold,jOld);
			return;
		}
		
		$("#extLoopVal").html(" "+extLoopVarName+"="+i.toFixed()+" ");
		$("#extLoopVal").show();
		$("#intLoopVal").html(" "+intLoopVarName+"="+j.toFixed()+" ");
		$("#intLoopVal").show();
        $("#matrixVal").html(" timh["+i+","+j+"]="+currentMatrix[i-1][j-1]+" ");
        $("#matrixVal").show();

        //διαγραφή κόκκινου πλαισίου
		if (showCopiedPixel && ((jOld>=jStart && jOld<=jEndVal && jStep>0) || (jOld<=jStart && jOld>=jEndVal && jStep<0))){
			cntx.strokeStyle="#FFFFFF";
			cntx.beginPath();
			cntx.rect(matrixBorder+(jOld-1)*cellWidth+cellBorder,matrixBorder+(iOld-1)*cellHeight+cellBorder,cellWidth-2*cellBorder,cellHeight-2*cellBorder);
			cntx.stroke();
		}

		// σχεδίαση κόκκινου πλαισίου
		if (showCopiedPixel && (j<=jEndVal && jStep>0 || j>=jEndVal && jStep<0)){
			cntx.strokeStyle="#FF0000";
			cntx.beginPath();
			cntx.rect(matrixBorder+(j-1)*cellWidth+cellBorder,matrixBorder+(i-1)*cellHeight+cellBorder,cellWidth-2*cellBorder,cellHeight-2*cellBorder);
			cntx.stroke();
			cntx.font="13px Georgia";
			cntx.fillStyle="blue";
			if(counter<noOfRows*noOfColumns/2){
				valOffset=0;
			}
			else{
				valOffset=cellHeight/2;
			}
			if(resultsStyle==0){
				if(i<=noOfRows && j<=noOfColumns){
					if (currentMatrix[i-1][j-1]>=previousValueShown){
						cntx.fillStyle="blue";
					}
					else{
						cntx.fillStyle="red";
					}
				}
				else{
					cntx.fillStyle="red";
				}

				
				cntx.font="11px Georgia";
				cntx.fillText(i,5*matrixBorder/3+noOfColumns*cellWidth,(counter+2)*cellHeight/2);
				cntx.fillText(j,5*matrixBorder/3+(noOfColumns+0.5)*cellWidth,(counter+2)*cellHeight/2);
				cntx.fillText(currentMatrix[i-1][j-1],5*matrixBorder/3+(noOfColumns+1.2)*cellWidth,(counter+2)*cellHeight/2);
			}
			else{//Ενναλακτική μέθοδος: Εμφάνιση τιμών σε δύο σειρές κάτω από τον πίνακα. Για ενεργοποίηση πρέπ[ει να τεθεί resultsStyle=1
				cntx.fillText(currentMatrix[i-1][j-1],matrixBorder/3+(counter % (noOfRows*noOfColumns/2))*cellWidth/2,matrixBorder+(noOfRows+1)*cellHeight+valOffset);
			}
		}
		if(i<=noOfRows && j<=noOfColumns){
			previousValueShown=currentMatrix[i-1][j-1];
		}
		else{
			previousValueShown=-100;
		}
		counter++;
		if(variationSelector==0){ //Πρώτη παραλλαγή εμφώλευσης
			jOld=j;
			j+=jStep;
			if(j>1) iOld=i;
			if(j>jEnd && jStep>0 || j<jEnd && jStep<0 || abortCode){
				i+=iStep;
				if(i>iEnd && iStep>0 || i<iEnd && iStep<0 || abortCode){
					tideUpCode(iOld,jOld);
				}
				else{
					j=UserFunctionOutput(varName1,varName2,document.getElementById("startVal2").innerHTML,0,i);
					jEnd=UserFunctionOutput(varName1,varName2,document.getElementById("endVal2").innerHTML,0,i);
				}
			}
		}
		else{ //Δεύτερη παραλλαγή εμφώλευσης
			iOld=i;
			i+=iStep;
			if(i>1) jOld=j;
			if(i>iEnd && iStep>0 || i<iEnd && iStep<0 || abortCode){
				j+=jStep;
				if(j>jEnd && jStep>0 || j<jEnd && jStep<0 || abortCode){
					tideUpCode(iOld,jOld);
				}
				else{
					i=UserFunctionOutput(varName1,varName2,document.getElementById("startVal2").innerHTML,j,0);
					iEnd=UserFunctionOutput(varName1,varName2,document.getElementById("endVal2").innerHTML,j,0);
				}
			}			
		}		
	},intervalPeriod);
}

function tideUpCode(iOld,jOld){
	clearInterval(codeInterval);
	//διαγραφή τελευταίου κόκκινου πλαισίου
	if (showCopiedPixel){
		cntx.strokeStyle="#FFFFFF";
		cntx.beginPath();
		cntx.rect(matrixBorder+(jOld-1)*cellWidth+cellBorder,matrixBorder+(iOld-1)*cellHeight+cellBorder,cellWidth-2*cellBorder,cellHeight-2*cellBorder);
		cntx.stroke();
	}
	toggleEditables("true");
	abortCode=false;
	/*$("#stopTool").hide(jQueryAnimationRate);
	$("#pauseTool").hide(jQueryAnimationRate);
	$("#runTool").show(jQueryAnimationRate);*/

	$("#btnStop").hide();
	$("#btnPause").hide();
	$("#btnPlay").show();
	
	$("#extLoopVal").hide();
	$("#intLoopVal").hide();
	$("#matrixVal").hide();
	programRunning=false;
}

function executeCode(variationSelector,startVal1,endVal1,stepVal1,startVal2,endVal2,stepVal2){
    var extLoopVarName="y";
    var intLoopVarName="x";
    var extCounter=0;
    var intCounter=0;
    var pixelData=dblBfrCntx.getImageData(0,0,1,1).data;
	var pixelSize=Math.max(zoomFactor-2,1);
	//αρχικοποίηση μεταβλητών
	var i=0,j=0;
	var iStart=0,jStart=0;
	var iStep=0,jStep=0;
	var iEnd=0,jEnd=0;
	var iOld=0,jOld=0;
	var simulationFinished=false;
	if(variationSelector==sweepByRow){ //Σάρωση κατά γραμμή
		iStart=startVal2;
		iEnd=endVal2;
		iStep=stepVal2;
		$("#cmd0").addClass("simulatingCode");
		i=iStart;

		if(currentPage==pgImageCopy){
			jStart=UserFunctionOutput(varName1,varName2,document.getElementById("startVal2").innerHTML,0,i);
			jEnd=UserFunctionOutput(varName1,varName2,document.getElementById("endVal2").innerHTML,0,i);
			jStep=UserFunctionOutput(varName1,varName2,document.getElementById("stepVal2").innerHTML,0,i);
		}
		else{
			jStart=UserFunctionOutput(varName1,varName2,document.getElementById("startVal1").innerHTML,i,0);
			jEnd=UserFunctionOutput(varName1,varName2,document.getElementById("endVal1").innerHTML,i,0);
			jStep=UserFunctionOutput(varName1,varName2,document.getElementById("stepVal1").innerHTML,i,0);
		}
		$(".simulatingCode").removeClass("simulatingCode");
		$("#cmd1").addClass("simulatingCode");
		j=jStart;
	}
	else{ //Σάρωση κατά στήλη
	    extLoopVarName="x";
	    intLoopVarName="y";
	    
		jStart=startVal1;
		jEnd=endVal1;
		jStep=stepVal1;
		$("#cmd0").addClass("simulatingCode");
		j=jStart;

		if(currentPage==pgImageCopy){
			iStart=UserFunctionOutput(varName1,varName2,document.getElementById("startVal2").innerHTML,j,0);
			iEnd=UserFunctionOutput(varName1,varName2,document.getElementById("endVal2").innerHTML,j,0);
			iStep=UserFunctionOutput(varName1,varName2,document.getElementById("stepVal2").innerHTML,j,0);
		}
		else{
			iStart=UserFunctionOutput(varName1,varName2,document.getElementById("startVal2").innerHTML,j,0);
			iEnd=UserFunctionOutput(varName1,varName2,document.getElementById("endVal2").innerHTML,j,0);
			iStep=UserFunctionOutput(varName1,varName2,document.getElementById("stepVal2").innerHTML,j,0);

		}
		$(".simulatingCode").removeClass("simulatingCode");
		$("#cmd1").addClass("simulatingCode");
		i=iStart;
	}
	iOld=-1;
	jOld=-1;

	codeInterval=setInterval(function(){
		if (programOnPause) return;
		if(simulationFinished){
			clearInterval(codeInterval);
			//διαγραφή τελευταίου κόκκινου pixel
			if (showCopiedPixel) restoreOriginalPixel(jOld,iOld,pixelSize,pixelData);
			toggleEditables("true");
			programRunning=false;
			abortCode=false;

            $("#btnPlay").show();
            $("#btnPause").hide();
            $("#btnStop").hide();
            
            $("#extLoopVal").hide();
            $("#intLoopVal").hide();
            if(currentPage<pgImageCopy){
                $("#btnZoomIn").show();
                $("#btnZoomOut").show();
            }

			advanceStep();
			return;
		}
		
		//διαγραφή κόκκινου pixel
		if (showCopiedPixel && ((jOld>=jStart && jOld<=jEnd && jStep>0) || (jOld<=jStart && jOld>=jEnd && jStep<0))){
			restoreOriginalPixel(jOld,iOld,pixelSize,pixelData);
		}

		// ανάγνωση χρώματος
		$(".simulatingCode").removeClass("simulatingCode");
		$("#cmd2").addClass("simulatingCode");
		pixelData=dblBfrCntx.getImageData(j,i,1,1).data;
		
		// σχεδίαση κόκκινου pixel
		if (showCopiedPixel && (j<=jEnd && jStep>0 || j>=jEnd && jStep<0)){
			drawRedPixel(j,i,pixelSize);
		}
		// σχεδίαση αντίγραφου
		$(".simulatingCode").removeClass("simulatingCode");
		$("#cmd3").addClass("simulatingCode");
		if ( (j<=jEnd && jStep>0 || j>=jEnd && jStep<0) && (i<=iEnd && iStep>0 || i>=iEnd && iStep<0)) drawCopy(variationSelector,j,i,pixelSize,pixelData);

		extCounter=variationSelector==sweepByRow?i:j;
        intCounter=variationSelector==sweepByRow?j:i;


        $("#extLoopVal").html(" "+extLoopVarName+"="+extCounter.toFixed()+" ");
        $("#extLoopVal").show();
        $("#intLoopVal").html(" "+intLoopVarName+"="+intCounter.toFixed()+" ");
        $("#intLoopVal").show();
		
		if(variationSelector==sweepByRow){//Σάρωση κατά γραμμή
			$(".simulatingCode").removeClass("simulatingCode");
			$("#cmd4").addClass("simulatingCode");
			jOld=j;
			j+=jStep;
			if(!redColumnVisible && (j>=jStart && jStep>0 || j<=jStart && jStep<0)) iOld=i;
			
			if(j>jEnd && jStep>0 || j<jEnd && jStep<0 || abortCode){ //Ολοκλήρωση εσωτερικής δομής
				if(currentPage==pgImageCopy){
					advanceStep();
				}
				if(redColumnVisible)iOld=i;
				$(".simulatingCode").removeClass("simulatingCode");
				$("#cmd5").addClass("simulatingCode");
				i+=iStep;
				if(i>iEnd && iStep>0 || i<iEnd && iStep<0 || abortCode){ //Ολοκλήρωση εξωτερικής Δομής
					simulationFinished=true;//Στην επόμενη εκτέλεση της Συνάρτησης θα γίνει η τακτοποίηση του τερματισμού και θα σβηστεί το τελευταίο κόκκινο pixel, επιτυρέποντας στο χρήστη να το παρατηρήσει για χρόνο ίσο με τα προηγούμενα
				}
				else{ //Αρχικοποίηση επόμενης επανάληψης εσωτερικής Δομής
					if(currentPage==pgImageCopy){
						j=UserFunctionOutput(varName1,varName2,document.getElementById("startVal2").innerHTML,0,i);
						jEnd=UserFunctionOutput(varName1,varName2,document.getElementById("endVal2").innerHTML,0,i);
					}
				}
			}
		}
		else{//Σάρωση κατά στήλη
			$(".simulatingCode").removeClass("simulatingCode");
			$("#cmd4").addClass("simulatingCode");
			iOld=i;
			i+=iStep;
			if(!redColumnVisible && (i>iStart && iStep>0 || i<iStart && iStep<0)) jOld=j;
			
			if(i>iEnd && iStep>0 || i<iEnd && iStep<0 || abortCode){ //Ολοκλήρωση εσωτερικής δομής
				if(currentPage==pgImageCopy){
					advanceStep();
				}
				if(redColumnVisible)jOld=j;
				$(".simulatingCode").removeClass("simulatingCode");
				$("#cmd5").addClass("simulatingCode");
				j+=jStep;
				if(j>jEnd && jStep>0 || j<jEnd && jStep<0 || abortCode){ //Ολοκλήρωση εξωτερικής Δομής
					simulationFinished=true;//Στην επόμενη εκτέλεση της Συνάρτησης θα γίνει η τακτοποίηση του τερματισμού και θα σβηστεί το τελευταίο κόκκινο pixel, επιτυρέποντας στο χρήστη να το παρατηρήσει για χρόνο ίσο με τα προηγούμενα
				}
				else{ //Αρχικοποίηση επόμενης επανάληψης εσωτερικής Δομής
					if(currentPage==pgImageCopy){
						i=UserFunctionOutput(varName1,varName2,document.getElementById("startVal2").innerHTML,j,0);
						iEnd=UserFunctionOutput(varName1,varName2,document.getElementById("endVal2").innerHTML,j,0);
					}
				}
			}
		}
	},intervalPeriod);
}

function restoreOriginalPixel(iOld,jOld,pixelSize,pixelData){
	switch(currentPage){
	case pgPixelCopy:
		//Καμμία λειτουργία
		break;
	case pgColumnCopy:
	case pgRowCopy:
		if (showCopiedPixel && jOld>-1) {
			cntx.scale(1/zoomFactor,1/zoomFactor);
			cntx.fillRect(indxBorder+zoomFactor*(iOld-zoomLeft)+1,zoomFactor*(jOld-zoomTop)+1,pixelSize,pixelSize);
			cntx.scale(zoomFactor,zoomFactor);
		}
		break;
	case pgImageCopy:
		if (showCopiedPixel && jOld>-1) {
			dblBfrCntx.drawImage(imgDemo,0,0,imgDemo.width,imgDemo.height);

			/*dblBfrCntx.fillStyle="rgb("+pixelData[0]+","+pixelData[1]+","+pixelData[2]+")";
			//cntx.scale(1/zoomFactor,1/zoomFactor);
			dblBfrCntx.fillRect(zoomFactor*iOld,zoomFactor*jOld,pixelSize,pixelSize);
			//cntx.scale(zoomFactor,zoomFactor);*/
		}
		break;
	}
}

function drawRedPixel(j,i,pixelSize){
	switch(currentPage){
	case pgPixelCopy:
		//Καμμία λειτουργία
		break;
	case pgColumnCopy:
	case pgRowCopy:
		cntx.scale(1/zoomFactor,1/zoomFactor);
		cntx.fillStyle="rgb(255,0,0)";
		cntx.fillRect(indxBorder+zoomFactor*(j-zoomLeft)+1,zoomFactor*(i-zoomTop)+1,pixelSize,pixelSize);
		cntx.scale(zoomFactor,zoomFactor);
		break;
	case pgImageCopy:
		//cntx.scale(1/zoomFactor,1/zoomFactor);
		dblBfrCntx.fillStyle="rgb(255,0,0)";
		//dblBfrCntx.fillRect(i-2,j-2,5,5);
		dblBfrCntx.fillRect(j-2,i-2,5,5);
		//cntx.scale(zoomFactor,zoomFactor);
		break;
	}
}

function drawCopy(variationSelector,j,i,pixelSize,pixelData){
	switch(currentPage){
	case pgPixelCopy:
		//Καμμία λειτουργία
		break;
	case pgColumnCopy:
	case pgRowCopy:
		cntx.scale(1/zoomFactor,1/zoomFactor);
		cntx.fillStyle="rgb("+pixelData[0]+","+pixelData[1]+","+pixelData[2]+")";
		cntx.fillRect(indxBorder+copyOffset+zoomFactor*(j-zoomLeft)+1,zoomFactor*(i-zoomTop)+1,pixelSize,pixelSize);
		cntx.scale(zoomFactor,zoomFactor);
		break;
	case pgImageCopy:
		var errorMessage="";
		var xScr=0,yScr=0;
		cntx.fillStyle="rgb("+pixelData[0]+","+pixelData[1]+","+pixelData[2]+")";
		if(j<0 || j>imgWidth || i<0 || i>imgHeight){
			errorMessage="Εκτός ορατών ορίων στο πρωτότυπο";
		}
		else{
			if(variationSelector==sweepByRow){
				xScr=UserFunctionOutput(varName1,varName2,document.getElementById("coord2").innerHTML,j,i);
				yScr=UserFunctionOutput(varName1,varName2,document.getElementById("coord1").innerHTML,j,i);
			}
			else{
				xScr=UserFunctionOutput(varName1,varName2,document.getElementById("coord1").innerHTML,j,i);
				yScr=UserFunctionOutput(varName1,varName2,document.getElementById("coord2").innerHTML,j,i);
			}
			if(xScr>=0){
				cntx.fillRect(copyOffset+xScr,yScr,1,1);
			}
			else{
				errorMessage="Εκτός ορατών ορίων στο αντίγραφο";
			}
		}
		showErrorMessage(errorMessage);
		break;
	}
}

function toggleEditables(newValue){
	$(".toChange").attr("contenteditable",newValue);
	if (newValue=="true"){
		$(".toChange").mouseenter(function() {
		    $(this).css("color", "#FF0000").css("background","#FFFF00");
		}).mouseleave(function() {
			$(this).css("color", "#0000FF").css("background","#FFFFFF");
		});
	}
	else{
		$(".toChange").mouseenter(function() {
		    $(this).css("color", "#0000FF").css("background","#FFFFFF");
		}).mouseleave(function() {
			$(this).css("color", "#0000FF").css("background","#FFFFFF");
		});
	}
}

function zoomIn(){
	if(zoomFactor<maxZoomFactor){
		if(currentPage!=pgImageCopy){
			//$("#zoomOutTool").show(jQueryAnimationRate);
			$("#btnZoomOut").attr("disabled",false);
		}
		zoomFactor++;
		if(zoomFactor==maxZoomFactor){
			//$("#zoomInTool").hide(jQueryAnimationRate);
			$("#btnZoomIn").attr("disabled",true);
		}
		zoomCanvas();
	}
}

function zoomOut(){
	if(zoomFactor>minZoomFactor){
		//$("#zoomInTool").show(jQueryAnimationRate);
		$("#btnZoomIn").attr("disabled",false);
		zoomFactor--;
		if(zoomFactor==minZoomFactor){
			//$("#zoomOutTool").hide(jQueryAnimationRate);
			$("#btnZoomOut").attr("disabled",true);
		}
		zoomCanvas();
	}
}

function zoomCanvas(){
	switch(currentPage){
	case pgPixelCopy:
	case pgRowCopy:
	case pgColumnCopy:
		showAdditionalCopyInfo();		
		copyOffset=zoomSize*zoomFactor+2*zoomFactor;
		canvas.width=indxBorder+copyOffset+zoomSize*zoomFactor;
		canvas.height=zoomFactor*zoomSize+indxBorder;
		break;
	case pgImageCopy:
		showAdditionalCopyInfo();
		copyOffset=0;
		canvas.width=imgWidth;
		canvas.height=imgHeight;
		break;
	}
	cntx.scale(zoomFactor,zoomFactor);
	prepareToShowImages();
}

function showAdditionalCopyInfo(x,y){
	var info="";
	//var alignment="";
	if(currentPage==pgImageCopy){
		info="<code>picture2</code>";
		//alignment="center";
	}
	else{
		info="Μεγέθυνση: x"+zoomFactor;
		if(x){
			info+=", mouse("+x+","+y+")";
		}
		//alignment="left";
	}
	//document.getElementById("zoomFactorInfo").style.textAlign=alignment;
	document.getElementById("zoomFactorInfo").innerHTML=info;
}

function dblBfrMouseDown(evt){
	switch(currentPage){
	case pgPixelCopy:
	case pgRowCopy:
	case pgColumnCopy:
    var rect=dblBuffer.getBoundingClientRect();
	var x=evt.clientX-rect.left;
    var y=evt.clientY-rect.top;
	if(dblBuffer.style.cursor=="pointer"){
    	zoomAreaGrabbed=true;
		zoomOffsetX=x-zoomLeft;
		zoomOffsetY=y-zoomTop;
	}
	break;
	}
}

function dblBfrMouseMove(evt){
    var rect=dblBuffer.getBoundingClientRect();
	var x=evt.clientX-rect.left;
    var y=evt.clientY-rect.top;
	switch(currentPage){
	case pgPixelCopy:
	case pgRowCopy:
	case pgColumnCopy:
		showMainImageInfo(parseInt(x),parseInt(y));
        if (zoomAreaGrabbed){
    		if(programRunning) stopCode();
        	zoomLeft=Math.min(Math.max(x-zoomOffsetX,0),imgWidth-zoomSize);
        	zoomTop=Math.min(Math.max(y-zoomOffsetY,0),imgHeight-zoomSize);
        	drawImages();
    		updateCode();
        }
        else{
            if (zoomLeft<x && zoomTop<y && zoomLeft+zoomSize>x && zoomTop+zoomSize>y){
            	dblBuffer.style.cursor="pointer";
            }
            else{
            	dblBuffer.style.cursor="auto";
            }
        }
        break;
	case pgImageCopy:
		showMainImageInfo(parseInt(x),parseInt(y));
	}
}

function dblBfrMouseUp(evt){
	switch(currentPage){
	case pgPixelCopy:
	case pgRowCopy:
	case pgColumnCopy:
		zoomAreaGrabbed=false;
		break;
	}
}

function canvasMouseDown(evt){
    /*var rect=canvas.getBoundingClientRect();
	var x=evt.clientX-rect.left;
    var y=evt.clientY-rect.top;
    */
}

function canvasMouseMove(evt){
    var rect=canvas.getBoundingClientRect();
	var x=evt.clientX-rect.left-indxBorder;
    var y=evt.clientY-rect.top;
    if (currentPage==pgPixelCopy && x>=0 && x<=zoomSize*zoomFactor && y<=zoomSize*zoomFactor){
    	advanceStep();
    	var pixelX=Math.floor(x/zoomFactor);
    	var pixelY=Math.floor(y/zoomFactor);
    	showAdditionalCopyInfo(zoomLeft+pixelX,zoomTop+pixelY);
		var pixelData=dblBfrCntx.getImageData(pixelX+zoomLeft,pixelY+zoomTop,1,1).data;
		cntx.fillStyle="rgb("+pixelData[0]+","+pixelData[1]+","+pixelData[2]+")";
		cntx.fillRect((indxBorder+copyOffset)/zoomFactor+pixelX,pixelY,1,1);
		drawGrid(copyOffset,zoomSize,zoomSize);
    }
    else{
    	showAdditionalCopyInfo();
    }
}

function canvasMouseUp(evt){
    /*var rect=canvas.getBoundingClientRect();
	var x=evt.clientX-rect.left;
    var y=evt.clientY-rect.top;
    */
}

function assembleCode(){
	var code="";
	switch(currentPage){
	case pgPixelCopy:
        code+="\n1: xroma <- picture1.getPixel(mouseX, mouseY)";
        code+="\n2: picture2.setPixel(mouseX, mouseY), xroma";
		break;
	case pgRowCopy:
        code+="<br>1:<span class='algoCmd' id='cmd1'> y <- <span class='toChange' id='selectedRow' contenteditable='true'>1</span></span>   <span class='showValues' id='extLoopVal' style='display: none;'></span>";
        code+="<br>2:<span class='algoCmd' id='cmd0'> <span class='reservedWord'>ΓΙΑ</span> x <span class='reservedWord'>ΑΠΟ</span> <span class='toChange' id='startVal1' contenteditable='true'>0</span> <span class='reservedWord'>ΜΕΧΡΙ</span> <span class='toChange' id='endVal1' contenteditable='true'>100</span> <span class='reservedWord'>ΜΕ_ΒΗΜΑ</span> <span class='toChange' id='stepVal1' contenteditable='true'>1</span></span>   <span class='showValues' id='intLoopVal' style='display: none;'></span>";
        code+="<br>3:<span class='algoCmd' id='cmd2'>   xroma <- picture1.getPixel(x,y)</span>";
        code+="<br>4:<span class='algoCmd' id='cmd3'>   picture2.setPixel(x , y),xroma</span>";
        code+="<br>5:<span class='algoCmd' id='cmd5'> <span class='reservedWord'>ΤΕΛΟΣ_ΕΠΑΝΑΛΗΨΗΣ</span></span>";
		break;
	case pgColumnCopy:
        code+="<br>1: x <- <span class='toChange' id='selectedColumn' contenteditable='true'>1</span>   <span class='showValues' id='extLoopVal' style='display: none;'></span>";
        code+="<br>2: <span class='reservedWord'>ΓΙΑ</span> y <span class='reservedWord'>ΑΠΟ</span> <span class='toChange' id='startVal2' contenteditable='true'>0</span> ΜΕΧΡΙ <span class='toChange' id='endVal2' contenteditable='true'>100</span> <span class='reservedWord'>ΜΕ_ΒΗΜΑ</span> <span class='toChange' id='stepVal2' contenteditable='true'>1</span>   <span class='showValues' id='intLoopVal' style='display: none;'></span>";
        code+="<br>3:   xroma <- picture1.getPixel(x,y)";
        code+="<br>4:   picture2.setPixel(x , y),xroma";
        code+="<br>5: <span class='reservedWord'>ΤΕΛΟΣ_ΕΠΑΝΑΛΗΨΗΣ</span>";
		break;
	case pgImageCopy:
        code+="<br>1:<span class='algoCmd' id='cmd0'> <span class='reservedWord'>ΓΙΑ</span> <span class='toChange' id='var1' contenteditable='true'>x</span>  <span class='reservedWord'>ΑΠΟ</span>  <span class='toChange' id='startVal1' contenteditable='true'>0</span> <span class='reservedWord'>ΜΕΧΡΙ</span> <span class='toChange' id='endVal1' contenteditable='true'>100</span> <span class='reservedWord'>ΜΕ_ΒΗΜΑ</span> <span class='toChange' id='stepVal1' contenteditable='true'>1</span></span>   <span class='showValues' id='extLoopVal' style='display: none;'></span>";
        code+="<br>2:<span class='algoCmd' id='cmd1'>   <span class='reservedWord'>ΓΙΑ</span> <span class='toChange' id='var2' contenteditable='true'>y</span>  <span class='reservedWord'>ΑΠΟ</span>  <span class='toChange' id='startVal2' contenteditable='true'>0</span> <span class='reservedWord'>ΜΕΧΡΙ</span> <span class='toChange' id='endVal2' contenteditable='true'>100</span> <span class='reservedWord'>ΜΕ_ΒΗΜΑ</span> <span class='toChange' id='stepVal2' contenteditable='true'>1</span></span>   <span class='showValues' id='intLoopVal' style='display: none;'></span>";
        code+="<br>3:<span class='algoCmd' id='cmd2'>     xroma <- picture1.getPixel(x,y)</span>";
        code+="<br>4:<span class='algoCmd' id='cmd3'>     picture2.setPixel(<span class='toChange' id='coord1' contenteditable='true'>x</span> , <span class='toChange' id='coord2' contenteditable='true'>y</span>),xroma</span>";
        code+="<br>5:<span class='algoCmd' id='cmd4'>   <span class='reservedWord'>ΤΕΛΟΣ_ΕΠΑΝΑΛΗΨΗΣ</span>";
        code+="<br>6:<span class='algoCmd' id='cmd5'> <span class='reservedWord'>ΤΕΛΟΣ_ΕΠΑΝΑΛΗΨΗΣ</span>";
		break;
	case pgSortedShow:
        code+="<br>1: <span class='reservedWord'>ΓΙΑ</span> <span class='toChange' id='var1' contenteditable='true'>j</span>  <span class='reservedWord'>ΑΠΟ</span>  <span class='toChange' id='startVal1' contenteditable='true'>1</span> <span class='reservedWord'>ΜΕΧΡΙ</span> <span class='toChange' id='endVal1' contenteditable='true'>"+noOfColumns+"</span> <span class='reservedWord'>ΜΕ_ΒΗΜΑ</span> <span class='toChange' id='stepVal1' contenteditable='true'>1</span>   <span class='showValues' id='extLoopVal' style='display: none;'></span>";
        code+="<br>2:   <span class='reservedWord'>ΓΙΑ</span> <span class='toChange' id='var2' contenteditable='true'>i</span>  <span class='reservedWord'>ΑΠΟ</span>  <span class='toChange' id='startVal2' contenteditable='true'>1</span> <span class='reservedWord'>ΜΕΧΡΙ</span> <span class='toChange' id='endVal2' contenteditable='true'>"+noOfRows+"</span> <span class='reservedWord'>ΜΕ_ΒΗΜΑ</span> <span class='toChange' id='stepVal2' contenteditable='true'>1</span>   <span class='showValues' id='intLoopVal' style='display: none;'></span>";
        code+="<br>3:     <span class='reservedWord'>ΓΡΑΨΕ</span> timh[i,j]   <span class='showValues' id='matrixVal' style='display: none;'></span>";
        code+="<br>4:   <span class='reservedWord'>ΤΕΛΟΣ_ΕΠΑΝΑΛΗΨΗΣ</span>";
        code+="<br>5: <span class='reservedWord'>ΤΕΛΟΣ_ΕΠΑΝΑΛΗΨΗΣ</span>";		
		break;
	}
	document.getElementById("sourceCode").innerHTML=code;
}

function updateCode(){
	//Σάρωση γραμμής
	if(currentPage==pgRowCopy){
		document.getElementById("selectedRow").innerHTML=zoomTop;
		document.getElementById("startVal1").innerHTML=zoomLeft;
		document.getElementById("endVal1").innerHTML=zoomLeft+zoomSize-1;
	}
	/*if(document.getElementById("selectedRow")){
		document.getElementById("selectedRow").innerHTML=zoomTop;
	}
	if(document.getElementById("startVal1")){
		document.getElementById("startVal1").innerHTML=zoomLeft;
	}
	if(document.getElementById("endVal1")){
		document.getElementById("endVal1").innerHTML=zoomLeft+zoomFactor;
	}*/
	
	//Σάρωση στήλης
	else if(currentPage==pgColumnCopy){
		document.getElementById("selectedColumn").innerHTML=zoomLeft;
		document.getElementById("startVal2").innerHTML=zoomTop;
		document.getElementById("endVal2").innerHTML=zoomTop+zoomSize-1;
	}
	
	/*if(document.getElementById("selectedColumn")){
		document.getElementById("selectedColumn").innerHTML=zoomLeft;
	}
	if(document.getElementById("startVal2")){
		document.getElementById("startVal2").innerHTML=zoomTop;
	}
	if(document.getElementById("endVal2")){
		document.getElementById("endVal2").innerHTML=zoomTop+zoomFactor;
	}*/
	else if(currentPage==pgImageCopy){
		document.getElementById("endVal1").innerHTML=imgWidth-1;
		document.getElementById("endVal2").innerHTML=imgHeight-1;
	}
}

function deleteCopy(){
	if(programRunning) return;
	switch(currentPage){
	case pgPixelCopy:
	case pgRowCopy:
	case pgColumnCopy:
		drawImages();
		break;
	case pgImageCopy:
		cntx.fillStyle="white";
		cntx.fillRect(0,0,canvas.width,canvas.height);
		break;
	case pgSortedShow:
	    if(selectedExercise>-1){
	        populateMatrix();
	    }
	    else{
	        cntx.fillStyle="white";
	        cntx.fillRect(0,0,canvas.width,canvas.height);
	    }
	    break;
	}
}

function selectPage(newPage){
    stopCode();
	currentPage=newPage;
	initialise();
}

function advanceStep(){
	var prompt="";
	noOfSteps++;
	var noOfStepsToReach=maxNoOfSteps[currentPage];
	if(noOfSteps==noOfStepsToReach){
	//if(noOfSteps==maxNoOfSteps[currentPage]){ //ΠΕΡΙΕΡΓΟ ΣΦΑΛΜΑ: η μεταβλητή currentPage εμφανίζεται ως undefined
		switch(currentPage){
		case pgPixelCopy:
			if(!firstPromptVisible){
				maxNoOfSteps[0]=2*maxNoOfSteps[0];
				firstPromptVisible=true;
				prompt="<p>Πειραματίσου για να δεις αν μπορείς να σαρώσεις τα pixel μιας ολόκληρης γραμμής....</p>";
			}
			else{
				$("#liRowCopy").show(jQueryAnimationRate,function(){sizeDIVs();});
				sizeDIVs();
                prompt="<p>Πειραματίσου για να δεις αν μπορείς να σαρώσεις τα pixel μιας ολόκληρης γραμμής....</p><p></p>";
				prompt+="<p>Αντί να κάνεις εσύ τόσες κινήσεις, προσπαθώντας να διατηρήσεις την ευθυγράμμιση του ποντικιού, μήπως θα ήταν απλούστερο να χρησιμοποιήσεις μια <i>Δομή Επανάληψης</i>;</p>";
				prompt+="<p>Για το σκοπό αυτό ενεργοποίησε την επιλογή: <b>"+document.getElementById("liRowCopy").innerHTML+"</b>";
				if(gradualContentOn){
					prompt+=" που μόλις εμφανίστηκε στην οθόνη σου.</p>";
				}
				else{
					prompt+=".</p>";
				}
			}
			break;
		case pgRowCopy:
			if(!firstPromptVisible){
				maxNoOfSteps[1]=3*maxNoOfSteps[1];
				firstPromptVisible=true;
				prompt="<p>Τροποποίησε την τιμή της μεταβλητής y στη γραμμή 1 του κώδικα για να σαρώσεις διαφορετικές γραμμές, συμπληρώνοντας το απόσπασμα της εικόνας.</p>";
			}
			else{
				$("#liColumnCopy").show(jQueryAnimationRate,function(){sizeDIVs();});
				sizeDIVs();
				prompt="<p>Θα μπορούσες να χρησιμοποιήσεις παρόμοιο κώδικα για να σαρώσεις στήλες της εικόνας.</p>";
				prompt+="<p>Για το σκοπό αυτό ενεργοποίησε την επιλογή: <b>"+document.getElementById("liColumnCopy").innerHTML+"</b>";
				if(gradualContentOn){
					prompt+=" που μόλις εμφανίστηκε στην οθόνη σου.</p>";
				}
				else{
					prompt+=".</p>";
				}
				
			}
			break;
		case pgColumnCopy:
			if(!firstPromptVisible){
				maxNoOfSteps[2]=3*maxNoOfSteps[2];
				firstPromptVisible=true;
				prompt="<p>Τροποποίησε την τιμή της μεταβλητής x στη γραμμή 1 του κώδικα για να σαρώσεις διαφορετικές στήλες, συμπληρώνοντας το απόσπασμα της εικόνας.</p>";
			}
			else{
				$("#liImageCopy").show(jQueryAnimationRate,function(){sizeDIVs();});
				sizeDIVs();
				prompt="<p>Αντί να εκτελείς τον κώδικα τόσες φορές όσες και οι στήλες του αντίγραφου, μήπως θα ήταν απλούστερο να χρησιμοποιήσεις μια <b>επιπλέον</b> Δομή Επανάληψης;</p>";
				prompt+="<p>Για να δοκιμάσεις αυτή την τεχνική ενεργοποίησε την επιλογή: <b>"+document.getElementById("liImageCopy").innerHTML+"</b>";
				if(gradualContentOn){
					prompt+=" που μόλις εμφανίστηκε στην οθόνη σου.</p>";
				}
				else{
					prompt+=".</p>";
				}
			}
			break;
		case pgImageCopy:
			if(!showExercises){
				if(!firstPromptVisible){
					maxNoOfSteps[3]=2*maxNoOfSteps[3];
					firstPromptVisible=true;
					prompt="<p>Φυσικά, ένας τέτοιος αλγόριθμος, λόγω της φτωχής επίδοσής του, μόνο <i>διδακτική</i> αξία έχει.</p>";
					prompt+="<p>Σε πραγματικές εφαρμογές χρησιμοποιούνται άλλοι αλγόριθμοι αντιγραφής, βελτιστοποιημένοι ως προς την ταχύτητα.</p>";
				}
				else{
					$("#liSortedShow").show(jQueryAnimationRate,function(){sizeDIVs();});
					sizeDIVs();
					prompt="<p>Αν και οι εντολές φαντάζουν αρκετά απλές, μπορείς <i>μόνο με αυτές</i> να πετύχεις ενδιαφέροντα και ποικίλα αποτελέσματα.</p>";
					prompt+="<p>Μπορείς να εξασκήσεις τις αλγοριθμικές σου ικανότητες με τις δοκιμασίες που θα βρεις <span class='clickableElement' onclick='presentExerciseMenu();'>εδώ</span>.</p>";
					prompt+="<p>Εναλλακτικά μπορείς να πειραματιστείς με άλλες εφαρμογές των Εμφωλευμένων Δομών Επανάληψης ενεργοποιώντας την επιλογή: <b>"+document.getElementById("liSortedShow").innerHTML+"</b>";
					if(gradualContentOn){
						prompt+=" που μόλις εμφανίστηκε στην οθόνη σου.</p>";
					}
					else{
						prompt+=".</p>";
					}
				}
			}
			break;
		}
		document.getElementById("showQuestion").innerHTML=prompt;
	}
}

function initialiseHint(){
	var hint="";
	switch(currentPage){
	case pgPixelCopy:
		hint="<p>Μετακίνησε το ποντίκι σου πάνω από τα pixel της μεγεθυμένης περιοχής για να ενεργοποιήσεις το απόσπασμα προγράμματος που βλέπεις στα αριστερά και να εκμεταλλευτείς την εντολή <code>getPixel(mouseX,mouseY)</code>, παρατηρώντας τις αναγραφόμενες συντεταγμένες mouseX και mouseY κάθε pixel. Παρατήρησε ότι οι τιμές στον άξονα y αυξάνονται καθως το ποντίκι κινείται προς τα <b>κάτω</b>.</p>";
		hint+="<p>Σύρε με το ποντίκι σου το κόκκινο παραλληλόγραμμο για να επιλέξεις διαφορετική περιοχή της πλήρους εικόνας για μεγέθυνση.</p>";
		break;
	case pgRowCopy:
		hint="<p>Μελέτησε τον κώδικα στα αριστερά προσπαθώντας να καταλάβεις τη λογική του.</p>";
		hint+="<p>Όταν είσαι σίγουρος ότι καταλαβαίνεις πως λειτουργεί, πάτησε το κουμπί ";
		hint+="<img src='css/images/icons-png/gear-black.png' class='referenceImage'>";
		hint+=" για να δεις το αποτέλεσμα της εκτέλεσής του.</p>";
		break;
	case pgColumnCopy:
		hint="<p>Σύγκρινε το νέο κώδικα με εκείνον που χρησιμοποιήσαμε για την <i>Αντιγραφή γραμμής</i>. Η λογική του θα πρέπει πλέον να είναι προφανής.</p>";
		break;
	case pgImageCopy:
		if(showExercises){
			selectedExercise=-1;
			hint+="<p>Διάλεξε μια από τις δοκιμασίες που βλέπεις στον κατάλογο.</p>";
			hint+="<p>";
			for(var i=0;i<noOfExercises;i++){
				var exNo=i+1;
				//hint+="<span class='clickableElement' onclick='presentSelectedExercise("+i+")'>Δοκιμασία "+exNo+"  ,  </span>";
				hint+=".<span class='clickableElement' onclick='presentSelectedExercise("+i+")'>  <img src='img/"+exNo+".png' class='referenceImage'>  </span>";
			}
			hint+=".</p>";
			hint+="<p>Θα τις αντιμετωπίσεις ευκολότερα αν χρησιμοποιήσεις <i>αλγεβρικές εκφράσεις</i>. Συμβουλέψου τις Οδηγίες (<img src='css/images/icons-png/bullets-black.png' class='referenceImage'>) για μια υπενθύμιση των αριθμητικών τελεστών και συναρτήσεων που μπορείς να χρησιμοποιήσεις.</p>";
			hint+="<p>Αν δεν καταφέρεις να λύσεις κάποια, χρησιμοποιήσε το κουμπί: <img src='img/showSolution.png' class='referenceImage'></p>";
		}
		else{
			hint="<p>Τρέξε το πρόγραμμα για να δεις τη διαδικασία αντιγραφής της εικόνας στην ολότητά της.";
			hint+="Λάβε υπόψη σου ότι οι συντεταγμένες ξεκινούν από το 0. Έτσι, σε μια οριζόντια γραμμή μήκους 100 pixel, οι συντεταγμένες x των σημείων κυμαίνονται από 0 μέχρι 99</p>";
			hint+="<p>Για ταχύτερη ολοκλήρωση του αποτελέσματος, μπορείς να δοκιμάσεις να αυξήσεις τις τιμές του βήματος μεταβολής στις δύο Δομές Επανάληψης. Το αντίγραφο δεν θα είναι συμπαγές, αλλά η διαδικασία θα ολοκληρώνεται ταχύτερα.</p>";
		}
		break;
	case pgSortedShow:
	    selectedExercise=-1;
		hint+="<p>Διάλεξε μια από τις δοκιμασίες που βλέπεις στον κατάλογο.</p>";
		hint+="<p>";
		for(var i=0;i<noOfSortingExercises;i++){
			var exNo=i+1;
			hint+=".<span class='clickableElement' onclick='presentSelectedExercise("+i+")'>  <img src='img/"+exNo+".png' class='referenceImage'>  </span>";
		}
		hint+=".</p>";
		break;
	}
	document.getElementById("showQuestion").innerHTML=hint;
	firstPromptVisible=false;
}


function setVolatileHelp(){
	var helpMsg="";
	switch(currentPage){
	case pgPixelCopy:
		$("#standardHelp").show(0);
		helpMsg+="<h2>ΚΩΔΙΚΟΠΟΙΗΣΗ ΕΙΚΟΝΑΣ</h2>";
		helpMsg+="<p style='text-shadow: none;'>Μια εικόνα αποτελείται απο εικονοστοιχεία (pixel) δηλαδή χρωματιστές κουκίδες.</p>";
		helpMsg+="<table>";
		helpMsg+="<tr>";
		helpMsg+="<td>Οι διαστάσεις των pixel είναι αρκετά μικρές ώστε το μάτι να τα συνθέτει και να βλέπει μια ολοκληρωμένη εικόνα:</td>";
		helpMsg+="<td>Γίνονται όμως ορατά αν μεγεθύνουμε την εικόνα:</td>";
		helpMsg+="</tr>";
		helpMsg+="<tr>";
		helpMsg+="<td><img src='img/landscape0.jpg'></td>";
		helpMsg+="<td><img src='img/landscapeZoom1.png'></td>";
		helpMsg+="</tr>";
		helpMsg+="</table>";
		helpMsg+="<p style='text-shadow: none;'>Οι γλώσσες προγραμματισμού διαθέτουν μια εντολή (π.χ. <code>getPixel(x,y)</code> ) για την ανάγνωση του χρώματος του pixel που βρίσκεται στη θέση με συντεταγμένες (x, y).</p>";
		helpMsg+="<p style='text-shadow: none;'>Κλείσε το παράθυρο αυτό για να πειραματιστείς με την <code>getPixel</code>.</p>";
		break;
	case pgRowCopy:
		$("#standardHelp").show(0);
		helpMsg+="<h2>ΔΟΜΗ ΕΠΑΝΑΛΗΨΗΣ (1/2)</h2>";
		helpMsg+="<p>Η <i>Δομή Επανάληψης</i> έχει την ιδιότητα να εκτελεί περισσότερες από μία φορές τις εντολές που περικλείει.</p>";
		helpMsg+="<p>Αντί να γράφουμε ένα σύνολο εντολών πολλές φορές, το πληκτρολογούμε μόνο μία και καθορίζουμε πόσες φορές επιθυμούμε να επαναληφθεί.</p>";
		helpMsg+="<p>Αν το πλήθος των επαναλήψεων είναι <b>εκ των προτέρων γνωστό</b>, όπως συμβαίνει π.χ. στην περίπτωση αντιγραφής τμήματος μιας εικόνας, μπορούμε να χρησιμοποιήσουμε μια μεταβλητή σε ρόλο μετρητή επαναλήψεων, στην οποία δίνονται διαδοχικά οι κατάλληλες τιμές.</p>";
		helpMsg+="<p>Διαφορετικά μπορούμε να βασιστούμε στον έλεγχο μίας ή περισσότερων συνθηκών.</p>";
		break;
	case pgColumnCopy:
		$("#standardHelp").show(0);
		helpMsg+="<h2>ΔΟΜΗ ΕΠΑΝΑΛΗΨΗΣ (2/2)</h2>";
		helpMsg+="<p id='mainIdea'>Η βασική ιδέα πίσω από τη Δομή Επανάληψης είναι ότι κάθε φορά εκτελούνται οι <b>ίδιες</b> εντολές, αλλά οι μεταβλητές έχουν <b>διαφορετικό</b> περιεχόμενο.</p>";
		helpMsg+="<p style='text-shadow: none;'>Έτσι, στο τέλος <i>κάθε</i> επανάληψης του προηγούμενου παραδείγματος τροποποιείται αυτόματα η τιμή της μεταβλητής <code>x</code>, με αποτέλεσμα η <code>getPixel</code> να αποθηκεύει στη μεταβλητή <code>xroma</code> το χρώμα του επόμενου προς τα δεξιά pixel και η <code>setPixel</code> να το αναπαράγει.</p>";
		helpMsg+="<p style='text-shadow: none;'>Με μια απλή εναλλαγή των μεταβλητών <code>x</code> και <code>y</code> μπορούμε να πετύχουμε σάρωση στήλης.</p>";
		helpMsg+="<p style='text-shadow: none;'>Για τη βελτίωση της αλγοριθμικής μας λογικής, είναι σημαντικό να αντιληφθούμε ότι από μόνες τους οι μεταβλητές αυτές δεν έχουν σχέση με συντεταγμένες σημείων επί της οθόνης.</p>";
		helpMsg+="<p style='text-shadow: none;'>Είναι η <i>σειρά</i> εμφάνισής τους ως παράμετροι στις εντολές <code>getPixel</code> και <code>setPixel</code> που εξασφαλίζει το επιθυμητό αποτέλεσμα.</p>";
		break;
	case pgImageCopy:
		$("#standardHelp").hide(0);
		if(showExercises){
			helpMsg+="<div style='text-shadow: none;'>";
			helpMsg+="<h2>ΔΙΑΘΕΣΙΜΟΙ ΑΡΙΘΜΗΤΙΚΟΙ ΤΕΛΕΣΤΕΣ</h2>";
			helpMsg+="<p>Πρόσθεση :  <code><i>όρισμα</i> + <i>όρισμα</i></code></p>";
			helpMsg+="<p>Αφαίρεση : <code><i>όρισμα</i> - <i>όρισμα</i></code></p>";
			helpMsg+="<p>Πολλαπλασιασμός : <code><i>όρισμα</i> * <i>όρισμα</i></code></p>";
			helpMsg+="<p>Διαίρεση πραγματικών αριθμών : <code><i>όρισμα</i> / <i>όρισμα</i></code></p>";
			helpMsg+="<h2>ΔΙΑΘΕΣΙΜΕΣ ΑΡΙΘΜΗΤΙΚΕΣ ΣΥΝΑΡΤΗΣΕΙΣ</h2>";
			helpMsg+="<p><code>sin(<i>όρισμα</i>)</code> : ημίτονο</p>";
			helpMsg+="<p><code>cos(<i>όρισμα</i>)</code> : συνημίτονο</p>";
			helpMsg+="<p><code>tan(<i>όρισμα</i>)</code> : εφαπτομένη</p>";
			helpMsg+="<p><code>e(<i>όρισμα</i>)</code> : εκθετική συνάρτηση με βάση τον αριθμό e του Euler (~2,72)</p>";
			helpMsg+="<p><code>ln(<i>όρισμα</i>)</code> : λογαριθμική συνάρτηση με βάση τον αριθμό e του Euler (~2,72)</p>";
			helpMsg+="<p><code>sqrt(<i>όρισμα</i>)</code> : τετραγωνική ρίζα μη αρνητικού αριθμού</p>";
			helpMsg+="<p><code>abs(<i>όρισμα</i>)</code> : απόλυτη τιμή</p>";
			helpMsg+="<h2>ΣΤΑΘΕΡΕΣ</h2>";
			helpMsg+="<p><code>π</code> : το πηλίκο της περιφέρειας προς τη διάμετρο του κύκλου (~3,14)</p>";
			helpMsg+="</div>";
		}
		else{
			helpMsg+="<h2>ΕΜΦΩΛΕΥΣΗ ΔΟΜΩΝ ΕΠΑΝΑΛΗΨΗΣ</h2>";
			helpMsg+="<p>Όπως αναφέρθηκε, μια δομή επανάληψης εκτελεί επαναληπτικά τις εντολές που περικλείει...";
			helpMsg+=" ακόμη και όταν αυτές συνιστούν μια δεύτερη Δομή Επανάληψης.</p>";
			helpMsg+="<p>Τα επόμενα αποσπάσματα κώδικα είναι ισοδύναμα ως προς το αποτέλεσμά τους.</p>";
			helpMsg+="<table class='demoCode' style='text-shadow: none;'>";
			helpMsg+="<tr>";
			helpMsg+="<td><code class='explanatoryCode'><p><span class='reservedWord'>ΓΡΑΨΕ</span> 'καλημέρα'</p><p><span class='reservedWord'>ΓΡΑΨΕ</span> 'καλημέρα'</p><p><span class='reservedWord'>ΓΡΑΨΕ</span> 'καλημέρα'</p></code></td>";
			helpMsg+="<td><code class='explanatoryCode'><p><span class='reservedWord'>ΓΙΑ</span> i <span class='reservedWord'>ΑΠΟ</span> 1 <span class='reservedWord'>ΜΕΧΡΙ</span> 3</p><p>  <span class='reservedWord'>ΓΡΑΨΕ</span> 'καλημέρα'</p><p><span class='reservedWord'>ΤΕΛΟΣ_ΕΠΑΝΑΛΗΨΗΣ</span></p></code></td>";
			helpMsg+="</tr>";
			helpMsg+="<tr>";
			helpMsg+="<td>Κάθε εντολή <code><span class='reservedWord'>ΓΡΑΨΕ</span></code> εκτελείται ακριβώς μία φορά, με αποτέλεσμα η λέξη 'καλημέρα' να εμφανίζεται στην οθόνη τρεις φορές.</td>";
			helpMsg+="<td>Η εντολή <code class='explanatoryCode'><span class='reservedWord'>ΓΡΑΨΕ</span></code> εκτελείται τρεις φορές, με αποτέλεσμα η λέξη 'καλημέρα' να εμφανίζεται στην οθόνη τρεις φορές.</td>";
			helpMsg+="</tr>";
			helpMsg+="</table>";
			helpMsg+="<p style='text-shadow: none;'>Αν περικλείσουμε ('εμφωλεύσουμε') κάθε ένα από τα ισοδύναμα αποσπάσματα κώδικα σε αντίγραφα της <b>ίδιας</b> Δομής Επανάληψης, προφανώς τα αποτελέσματα θα παραμείνουν ισοδύναμα.</p>";
			helpMsg+="<table class='demoCode' style='text-shadow: none;'>";
			helpMsg+="<tr>";
			helpMsg+="<td><code class='explanatoryCode'><p><span class='reservedWord'>ΓΙΑ</span> j <span class='reservedWord'>ΑΠΟ</span> 1 <span class='reservedWord'>ΜΕΧΡΙ</span> 5</p><p>  <span class='reservedWord'>ΓΡΑΨΕ</span> 'καλημέρα'</p><p>  <span class='reservedWord'>ΓΡΑΨΕ</span> 'καλημέρα'</p><p>  <span class='reservedWord'>ΓΡΑΨΕ</span> 'καλημέρα'</p><p><span class='reservedWord'>ΤΕΛΟΣ_ΕΠΑΝΑΛΗΨΗΣ</span></p></code></td>";
			helpMsg+="<td><code class='explanatoryCode'><p><span class='reservedWord'>ΓΙΑ</span> j <span class='reservedWord'>ΑΠΟ</span> 1 <span class='reservedWord'>ΜΕΧΡΙ</span> 5</p><p>  <span class='reservedWord'>ΓΙΑ</span> i <span class='reservedWord'>ΑΠΟ</span> 1 <span class='reservedWord'>ΜΕΧΡΙ</span> 3</p><p>    <span class='reservedWord'>ΓΡΑΨΕ</span> 'καλημέρα'</p><p>  <span class='reservedWord'>ΤΕΛΟΣ_ΕΠΑΝΑΛΗΨΗΣ</span></p><p><span class='reservedWord'>ΤΕΛΟΣ_ΕΠΑΝΑΛΗΨΗΣ</span></p></code></td>";
			helpMsg+="</tr>";
			helpMsg+="<tr>";
			helpMsg+="<td>Η τριάδα των εντολών <code><span class='reservedWord'>ΓΡΑΨΕ</span></code> εκτελείται ακριβώς πέντε φορές, άρα στην οθόνη εμφανίζεται η λέξη 'καλημέρα' δεκαπέντε φορές.</td>";
			helpMsg+="<td>Η τριπλή εκτέλεση της εντολής <code><span class='reservedWord'>ΓΡΑΨΕ</span></code> πραγματοποιείται πέντε φορές, με αποτέλεσμα η λέξη 'καλημέρα' να εμφανίζεται στην οθόνη δεκαπέντε φορές.</td>";
			helpMsg+="</tr>";
			helpMsg+="</table>";
			helpMsg+="<p style='text-shadow: none;'>ΣΥΝΕΠΩΣ: Η εμφώλευση των Δομών Επανάληψης λειτουργεί <b>πολλαπλασιαστικά</b> ως προς το πλήθος των επαναλήψεων.</p>";
		}
		break;
	case pgSortedShow:
		$("#standardHelp").hide(0);
		helpMsg+="<div style='text-shadow: none;'>";
		helpMsg+="<h2>ΣΑΡΩΣΗ ΟΡΘΟΓΩΝΙΑΣ ΔΙΑΤΑΞΗΣ ΔΕΔΟΜΕΝΩΝ</h2>";
		helpMsg+="<p>Όλα τα δεδομένα, ανεξάρτητα από τη μορφή του, αποθηκεύονται στη μνήμη του υπολογιστή σαν αριθμοί (με τη μορφή δυαδικής αναπαράστασης).</p>";
		helpMsg+="<p>Αυτοί ισχύει είτε τα δεδομένα αυτά είναι αριθμοί, είτε γράμματα και άλλοι χαρακτήρες που συνθέτουν κείμενο, είτε χρώμα εικονοστοιχείου, είτε ήχος κ.λπ. </p>";
		helpMsg+="<p>Στην ενότητα αυτή θα αντικαταστήσουμε το χρώμα κάθε pixel με κάποιον αριθμό και θα έχεις την ευκαιρία να εκμεταλλευτείς τη Δομή Επανάληψης σε μια σειρά δοκιμασιών διαφορετικού ύφους.</p>";
		helpMsg+="<p>Παρατήρησε ότι στο νέο απόσπασμα κώδικα η αναφορά γίνεται κατά τρόπο <b>αντίστροφο</b> εκείνου που χρησιμοποιούμε στις γραφικές παραστάσεις, δηλαδή πρώτα με το δείκτη γραμμής και μετά με το δείκτη στήλης.</p>";
		helpMsg+="</div>";
		break;
	}
	document.getElementById("volatileHelp").innerHTML=helpMsg;
	$("#closeTool").removeClass("ui-link");
	$("#gradualContent").removeClass("ui-checkbox");
	var checkedState="";
	if(gradualContentOn) checkedState="checked";
	$("#checkboxSpan").html("<input type='checkbox' id='gradualContent' onchange='setAppBehaviour()' "+checkedState+">");
}

function setAppBehaviour(){
	gradualContentOn=document.getElementById("gradualContent").checked;
	if(gradualContentOn){
		$("#liPixelCopy").show(0);		
		if(currentPage>=pgRowCopy){
			$("#liRowCopy").show(0);
		}
		else{
			$("#liRowCopy").hide(0);
		}
		if(currentPage>=pgColumnCopy){
			$("#liColumnCopy").show(0);
		}
		else{
			$("#liColumnCopy").hide(0);
		}
		if(currentPage>=pgImageCopy){
			$("#liImageCopy").show(0);
		}
		else{
			$("#liImageCopy").hide(0);
		}
		if(currentPage>=pgSortedShow){
			$("#liSortedShow").show(0);
		}
		else{
			$("#liSortedShow").hide(0);
		}
	}
	else{
		$("#liPixelCopy").show(0);		
		$("#liRowCopy").show(0);
		$("#liColumnCopy").show(0);
		$("#liImageCopy").show(0);
		$("#liSortedShow").show(0);
	}
	sizeDIVs();
}

/*function showAppID(){
	window.open("index_DS_II.html","_newtab");
}*/

function placeDIVs(){
    sizeDIVs();
    var horizontalBorder=8;
    $("#codeDiv").css({left: horizontalBorder});
    $("#showQuestion").css({left: $("#codeDiv").outerWidth()+3*horizontalBorder});
}

function hideHelp(){
	$("#openModalHelp").hide();
}

function showHelp(){
    var availableHeight=window.innerHeight-48;
    if(availableHeight>100){
        $("#openModalHelp").show();
        $("#helpContent").css("height","auto");        
        var maxHeight=$("#helpContent").height();
        var heightToUse=availableHeight<maxHeight?availableHeight:maxHeight;
        $("#helpContent").height(heightToUse);
    }
    else{
        alert("Δεν υπάρχει αρκετός διαθέσιμος χώρος για εμφάνιση του παράθυρου βοήθειας. Παρακαλώ μεγαλώστε το παράθυρο και δοκιμάστε ξανά.");
    }
}